
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1998][royale@ifrance.com]ͼ
                --  :*)

program lx7;

uses dos,crt,lx_keys;

const scrn_pg=ptr($A000,0);
      {$i setup.inc}

type tir_typ=record
       x,y:integer;
       inplay:boolean;
       spe:real;
     end;
     good_typ=record
       x,y:integer;
       inplay:boolean;
       score:word;
       max_fuel,fuel:longint;
       max_life,life:word;
       typ,col,spe,ha,la:byte;
       arme:byte;
       nom:string[8];
       tir:array [1..max_good_tirs] of tir_typ;
     end;
     bad_typ=record
       x,y:integer;
       inplay:boolean;
       mx,my:shortint;
       life,typ,ha,la:byte;
       tir:array [1..max_bad_tirs] of tir_typ;
     end;
     best=array [1..10] of record nom,date:string; score:word; typ:byte; end;

var star_pg,make_pg,ship_pg:pointer;   {pointeurs de pages virtuelles.}
    dif:word;
    good:array [1..4] of good_typ;
    bad:array [1..max_bad] of bad_typ;
    i,j,k:word;
    temp:string;
    fic:file of best;
    royale:best;
    ok:boolean;
    cmpt,col:byte;
    mcol:shortint;
    lifecod,fuelcod,shipcod:boolean;
    pcxfile:file;

    {$i police.inc}
    {$i pcx.inc}

procedure init_mode13;               {initialise le mode 13.}
begin
  getmem(make_pg,64000);
  getmem(star_pg,64320);
  getmem(ship_pg,64000);
  asm
    mov ax,13h
    int 10h
  end;
end;

procedure close_mode13;              {ferme le mode 13 et les pointers.}
begin
  freemem(make_pg,64000);
  freemem(star_pg,64320);
  freemem(ship_pg,64000);
  asm
    mov ax,03h
    int 10h
  end;
end;

procedure copypage(source,dest:pointer; dif:word); assembler;
asm
  push ds
  les di,dest
  lds si,source
  add si,dif
  mov cx,320*200/4
  db 66h;rep movsw
  pop ds
end;

procedure clearpage(page:pointer); assembler;
asm
  les di,page
  mov cx,320*200/4
  db 66h;xor ax,ax
  db 66h;rep stosw
end;

procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask:boolean); assembler;
asm
  push ds

  cmp x,0
  je @fin
  cmp y,0
  je @fin

  lds si,source
  les di,dest

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov bx,320
  sub bx,x                  {met dans bx le dcalage de fin de ligne.}
  mov cx,y                  {met dans le compteur cx la largeur y.}

  cmp mask,false            {si masque est faux, on saute  la sous-procedure}
  je @sprite                {putsprite...}

  @boucle:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @boucle
  jmp @fin

  @sprite:
    push cx
    mov cx,x
    @line:
      mov ah,ds:[si]
      or ah,ah
      je @noir
      mov es:[di],ah
      @noir:
      inc di
      inc si
      dec cx
    jnz @line
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @sprite

  @fin:
  pop ds
end;

procedure playson(note,dure:word);
begin
  if son then begin
    sound(note);
    delay(dure);
    nosound;
  end;
end;

procedure mise_a_zero;
begin
  for i:=1 to 4 do with good[i] do begin
    x:=10;
    y:=(i-1)*55+10;
    case typ of
      1:begin la:=35; ha:=25; spe:=spe_red1; max_life:=life_red1; max_fuel:=fuel_red1; arme:=arme_red1; end;
      2:begin la:=16; ha:=11; spe:=spe_red2; max_life:=life_red2; max_fuel:=fuel_red2; arme:=arme_red2; end;
      3:begin la:=16; ha:=6;  spe:=spe_red3; max_life:=life_red3; max_fuel:=fuel_red3; arme:=arme_red3; end;
      4:begin la:=160; ha:=35; spe:=spe_red3; max_life:=life_red1; max_fuel:=fuel_red1; arme:=arme_red1; end;
    end;
    life:=max_life;
    fuel:=max_fuel;
    if nom<>'' then inplay:=true;
    score:=0;
    for j:=1 to max_good_tirs do tir[j].inplay:=false;
  end;
  for i:=1 to max_bad do with bad[i] do begin
    inplay:=false;
    for j:=1 to max_bad_tirs do tir[j].inplay:=false;
  end;
  ok:=false;
end;

procedure init_joueurs;
var nt:integer;
    cc:char;
    compt,ou:byte;
    s:string;
begin
  col:=40;
  mcol:=1;
  ou:=1;
  compt:=0;
  for i:=1 to 4 do good[i].typ:=1;
  repeat
    if keypressed then begin
      cc:=readkey;
      if cc=#0 then begin
	cc:=readkey;
	nt:=1000+ord(cc)
      end
      else nt:=ord(cc);
      case nt of
	8:if compt>0 then begin
	  delete(good[ou].nom,compt,1);
	  dec(compt);
	end;
	32..255:if compt<8 then begin
	  inc(compt);
	  insert(upcase(chr(nt)),good[ou].nom,compt);
	end;
	13:if shipcod then if good[ou].typ<4 then inc(good[ou].typ) else good[ou].typ:=1
           else if good[ou].typ<3 then inc(good[ou].typ) else good[ou].typ:=1;
	1072:begin if ou>1 then dec(ou) else ou:=4; compt:=length(good[ou].nom); end;
	1080:begin if ou<4 then inc(ou) else ou:=1; compt:=length(good[ou].nom); end;
      end;
    end;
    if scroll then begin
      inc(dif);
      if dif>319 then dif:=0;
      copypage(star_pg,make_pg,dif);
    end else clearpage(make_pg);
    copyblock(8,9,ship_pg,312,190,make_pg,40,ou*40,cache);
    inc(col,mcol);
    if (col<40) or (col>50) then mcol:=-mcol;
    outtextxy(60,0,'APPUYER SUR ECHAP POUR QUITTER',col);
    outtextxy(72,10,'ENTREE POUR CHANGER DE RED',col);
    for i:=1 to 4 do with good[i] do begin
      if nom<>'' then begin
	case typ of
	  1:begin la:=35; ha:=25; end;
	  2:begin la:=16; ha:=11; end;
	  3:begin la:=16; ha:=6;  end;
          4:begin la:=160; ha:=35; end;
	end;
	if typ=1 then copyblock(la,ha,ship_pg,(i-1)*la+96,13,make_pg,230,10+i*40-ha div 2,cache);
	if typ=2 then copyblock(la,ha,ship_pg,(i-1)*la,0,make_pg,230,10+i*40-ha div 2,cache);
	if typ=3 then case i of
	  1:copyblock(la,ha,ship_pg,64,0,make_pg,230,10+i*40-ha div 2,cache);
	  2:copyblock(la,ha,ship_pg,80,0,make_pg,230,10+i*40-ha div 2,cache);
	  3:copyblock(la,ha,ship_pg,80,6,make_pg,230,10+i*40-ha div 2,cache);
	  4:copyblock(la,ha,ship_pg,64,6,make_pg,230,10+i*40-ha div 2,cache);
	end;
        if typ=4 then copyblock(la,ha,ship_pg,0,38,make_pg,159,10+i*40-ha div 2,cache);
	str(typ,s);
	outtextxy(60,15+i*40,'SUR RED '+s,col);
      end;
      str(i,s);
      outtextxy(60,i*40,'NOM DU JOUEUR '+s+' : '+nom,col);
    end;
    copypage(make_pg,scrn_pg,0);
    delay(pentium);
  until port[$60]=1;
end;

    {$i royale.inc}

procedure init;
begin
  for i:=1 to paramcount do begin
    if (paramstr(i)='/strong') or (paramstr(i)='/STRONG') then lifecod:=true;
    if (paramstr(i)='/tanker') or (paramstr(i)='/TANKER') then fuelcod:=true;
    if (paramstr(i)='/bigger') or (paramstr(i)='/BIGGER') then shipcod:=true;
  end;
  good[1].col:=40;
  good[2].col:=50;
  good[3].col:=60;
  good[4].col:=30;
  init_mode13;
  royale_presentation;
  loadpcx('image3.pcx',star_pg);
  loadpcx('title.pcx',ship_pg);
  for i:=1 to 160 do begin
    if port[$60]=1 then begin
      repeat until port[$60]<>1;
      i:=160;
    end;
    copypage(star_pg,make_pg,0);
    copyblock(i,199,ship_pg,160-i,0,make_pg,0,0,cache);
    copyblock(i,199,ship_pg,160,0,make_pg,320-i,0,cache);
    copypage(make_pg,scrn_pg,0);
    delay(pentium);
  end;
  playson(2000,50);
  delay(50);
  playson(3000,50);
  delay(2000);
  fillchar(star_pg^,64320,0);
  for i:=0 to 1000 do
    mem[seg(star_pg^):random(320)+random(201)*320]:=random(12)+16;
  clearpage(scrn_pg);
  loadpcx('lx.pcx',ship_pg);
  init_joueurs;
  installkey;
  randomize;
end;

procedure best_score;
var annee,mois,jour,day:word;
begin
  {$i-}
  assign(fic,'score.lx');
  reset(fic);
  read(fic,royale);
  if not (lifecod or fuelcod or shipcod) then
  for i:=1 to 4 do with good[i] do for j:=1 to 10 do if score>royale[j].score then begin
    for k:=10 downto j+1 do royale[k]:=royale[k-1];
    royale[j].nom:=nom;
    royale[j].score:=score;
    royale[j].typ:=typ;
    getdate(annee,mois,jour,day);
    str(jour,temp);
    if jour in [0..9] then insert('0',temp,1);
    royale[j].date:=temp+'/';
    str(mois,temp);
    if mois in [0..9] then insert('0',temp,1);
    royale[j].date:=royale[j].date+temp+'/';
    str(annee,temp);
    royale[j].date:=royale[j].date+temp;
    j:=10;
  end;
  rewrite(fic);
  write(fic,royale);
  close(fic);
  {$i+}
end;

procedure show_score;
begin
  if not ok then begin
    best_score;
    ok:=true;
    col:=40;
    mcol:=1;
  end;
  inc(col,mcol);
  if (col<40) or (col>50) then mcol:=-mcol;
  outtextxy(100,40,'TABLEAU DES SCORES',col);
  for i:=1 to 10 do begin
    str(royale[i].score,temp);
    outtextxy(26,i*10+50,royale[i].nom,col);
    outtextxy(80,i*10+50,' : '+temp,col);
    outtextxy(140,i*10+50,'LE '+royale[i].date,col);
    str(royale[i].typ,temp);
    outtextxy(230,i*10+50,'SUR RED '+temp,col);
  end;
end;

procedure pause;
begin
  repeat until not F2;
  clearpage(scrn_pg);
  str(random(3)+1,temp);
  loadpcx('image'+temp+'.pcx',make_pg);
  outtextxy(132,175,'PAUSE',100);
  outtextxy(70,185,'APPUYER SUR F2 POUR QUITTER',100);
  copypage(make_pg,scrn_pg,0);
  repeat until F2;
  repeat until not F2;
  clearpage(scrn_pg);
  assign(pcxfile,'lx.pcx');
  reset(pcxfile,1);
  seek(pcxfile,filesize(pcxfile)-768);
  blockread(pcxfile,pal,768);
  setpal;
  close(pcxfile);
end;

procedure boum(x,y:word);
begin
  if x<320 then if x<=306 then
    copyblock(13,13,ship_pg,160,0,make_pg,x,y,cache) else copyblock(320-x,13,ship_pg,160,0,make_pg,x,y,cache);
  playson(1000,20);
end;

function point(i:byte):byte;
begin
  case i of
    1:point:=10;
    2:point:=12;
    3:point:=25;
    4:point:=20;
    5:point:=15;
    6:point:=100;
    7:point:=150;
    8:point:=250;
  end;
end;

procedure option(var cible:bad_typ);
begin
  if random(freq_option)=0 then with cible do begin
    mx:=-bad_spe;
    my:=0;
    case random(52) of
	   0:typ:=28;
	1..5:typ:=10;
	6..9:typ:=11;
      10..12:typ:=12;
      13..14:typ:=13;
	  15:typ:=14;
      16..20:typ:=15;
      21..24:typ:=16;
      25..27:typ:=17;
      28..29:typ:=18;
	  30:typ:=19;
      31..35:typ:=20;
      36..39:typ:=21;
      40..42:typ:=22;
      43..44:typ:=23;
	  45:typ:=24;
          46..48:typ:=25;
          49..50:typ:=26;
          51:typ:=27;
    end;
    if typ=28 then begin la:=14; ha:=7; end
    else begin la:=7; ha:=9; end;
  end else cible.inplay:=false;
end;

procedure move_good;
begin
  with good[i] do if inplay then begin
    if U[i] and (fuel<>0) then begin
      dec(y,spe);
      if not fuelcod then dec(fuel);
    end;
    if D[i] and (fuel<>0) then begin
      inc(y,spe);
      if not fuelcod then dec(fuel);
    end;
    if L[i] and (fuel<>0) then begin
      dec(x,spe);
      if not fuelcod then dec(fuel);
    end;
    if R[i] and (fuel<>0) then begin
      inc(x,spe);
      if not fuelcod then dec(fuel);
    end;
    if x<7 then x:=7;
    if x>312-la then x:=312-la;
    if y<7 then y:=7;
    if y>192-ha then y:=192-ha;
    if F[i] then case arme of
      0:for j:=1 to max_good_tirs do if not tir[j].inplay then begin
          tir[j].inplay:=true;
          tir[j].x:=x+la;
          tir[j].y:=y+ha div 2;
          tir[j].spe:=spe;
          j:=max_good_tirs;
        end;
      1:for j:=1 to max_good_tirs do if not tir[j].inplay then
        if j<max_good_tirs then for k:=j+1 to max_good_tirs do if not tir[k].inplay then begin
          tir[j].inplay:=true;
          tir[j].x:=x+la;
          tir[j].y:=y+ha div 2;
          tir[j].spe:=spe;
          tir[k].inplay:=true;
          tir[k].x:=x;
          tir[k].y:=y+ha div 2;
          tir[k].spe:=-spe;
          k:=max_good_tirs;
          j:=max_good_tirs;
        end;
      2:for j:=1 to max_good_tirs do if not tir[j].inplay then
        if j<max_good_tirs then for k:=j+1 to max_good_tirs do if not tir[k].inplay then begin
          tir[j].inplay:=true;
          tir[j].x:=x+la;
          tir[j].y:=y+ha div 3;
          tir[j].spe:=spe;
          tir[k].inplay:=true;
          tir[k].x:=x+la;
          tir[k].y:=y+2*ha div 3;
          tir[k].spe:=spe;
          k:=max_good_tirs;
          j:=max_good_tirs;
        end;
      end;
    if col_good and not lifecod then for j:=1 to 4 do
      if (i<>j) and good[j].inplay and (good[j].x+good[j].la>x) and (good[j].x<x+la)
      and (good[j].y+good[j].ha>y) and (good[j].y<y+ha) then begin
      dec(life);
      if life<=0 then begin
	inplay:=false;
	boum(x+la div 2-7,y+ha div 2-7);
      end;
      dec(good[j].life);
      if good[j].life<=0 then begin
	good[j].inplay:=false;
	boum(good[j].x+good[j].la div 2-7,good[j].y+good[j].ha div 2-7);
      end;
    end;
    if typ=1 then copyblock(la,ha,ship_pg,(i-1)*la+96,13,make_pg,x,y,cache);
    if typ=2 then copyblock(la,ha,ship_pg,(i-1)*la,0,make_pg,x,y,cache);
    if typ=3 then case i of
      1:copyblock(la,ha,ship_pg,64,0,make_pg,x,y,cache);
      2:copyblock(la,ha,ship_pg,80,0,make_pg,x,y,cache);
      3:copyblock(la,ha,ship_pg,80,6,make_pg,x,y,cache);
      4:copyblock(la,ha,ship_pg,64,6,make_pg,x,y,cache);
    end;
    if typ=4 then copyblock(la,ha,ship_pg,0,38,make_pg,x,y,cache);
  end;
  for k:=1 to max_good_tirs do with good[i].tir[k] do if inplay then begin
    if spe>0 then spe:=spe+miss_acc else spe:=spe-miss_acc;
    inc(x,round(spe));
    if (x<0) or (x>319) then inplay:=false else putpixel(x,y,good[i].col);
    if tir_good then for j:=1 to 4 do
    if good[j].inplay and (x>=good[j].x) and (x<=good[j].x+good[j].la)
    and (y>=good[j].y) and (y<=good[j].y+good[j].ha) then begin
      inplay:=false;
      if not lifecod then dec(good[j].life);
      if good[j].life<=0 then begin
	good[j].inplay:=false;
	boum(good[j].x+good[j].la div 2-7,good[j].y+good[j].ha div 2-7);
      end;
    end;
    for j:=1 to max_bad do
    if bad[j].inplay and (bad[j].typ<10) and (x>=bad[j].x)
    and (x<=bad[j].x+bad[j].la) and (y>=bad[j].y) and (y<=bad[j].y+bad[j].ha)
    then begin
      inplay:=false;
      dec(bad[j].life);
      if bad[j].life<=0 then begin
	if good[i].inplay then inc(good[i].score,point(bad[j].typ));
	if bad[j].typ<6 then boum(bad[j].x+bad[j].la div 2-7,bad[j].y+bad[j].ha div 2-7)
        else for cmpt:=1 to bad[j].typ do boum(bad[j].x+random(bad[j].la)-7,bad[j].y+random(bad[j].ha)-7);
	option(bad[j]);
      end;
    end;
  end;
end;

procedure new_bad;
begin
  with bad[i] do if not inplay and (random(app_freq)=0) then begin
    case random(2000) of
      0:begin typ:=8; life:=200; mx:=-bad_spe*3; my:=(random(3)-1)*bad_spe*3; la:=160;ha:=35; end;
      1..5:begin typ:=6; life:=100; mx:=-bad_spe*2; my:=(random(3)-1)*bad_spe*2; la:=47;ha:=25; end;
      6..15:begin typ:=7; life:=150; mx:=-bad_spe*2; my:=(random(3)-1)*bad_spe*2; la:=104;ha:=37; end;
      16..500:begin typ:=1; life:=1; mx:=-bad_spe*3; my:=(random(3)-1)*bad_spe*3; la:=16; ha:=9; end;
      501..1000:begin typ:=2; life:=2; mx:=-bad_spe*2; my:=(random(3)-1)*bad_spe*2; la:=16; ha:=11; end;
      1001..1300:begin typ:=3; life:=3; mx:=-bad_spe*3; my:=(random(3)-1)*bad_spe*3; la:=16; ha:=8; end;
      1301..1700:begin typ:=4; life:=5; mx:=-bad_spe*2; my:=(random(3)-1)*bad_spe*2; la:=16; ha:=11; end;
      1701..1999:begin typ:=5; life:=10; mx:=-bad_spe; my:=(random(3)-1)*bad_spe; la:=11;ha:=11; end;
    end;
    inplay:=true;
    x:=320;
    y:=random(186-ha)+7;
  end;
end;

procedure move_bad;
begin
  with bad[i] do if inplay then begin
    x:=x+mx;
    y:=y+my;
    if (y<7) or (y>192-ha) then my:=-my;
    if ((x<7) or ((x>312-la) and (mx>0))) then if (typ<10) then mx:=-mx else inplay:=false;
    if x>320-la then
    case typ of
      1:copyblock(320-x,ha,ship_pg,112,0,make_pg,x,y,cache);
      2:copyblock(320-x,ha,ship_pg,144,0,make_pg,x,y,cache);
      3:copyblock(320-x,ha,ship_pg,189,0,make_pg,x,y,cache);
      4:copyblock(320-x,ha,ship_pg,221,0,make_pg,x,y,cache);
      5:copyblock(320-x,ha,ship_pg,237,0,make_pg,x,y,cache);
      6:copyblock(320-x,ha,ship_pg,47,13,make_pg,x,y,cache);
      7:copyblock(320-x,ha,ship_pg,104,73,make_pg,x,y,cache);
      8:copyblock(320-x,ha,ship_pg,160,38,make_pg,x,y,cache);
      10..27:copyblock(320-x,ha,ship_pg,186+(typ-10)*la,191,make_pg,x,y,cache);
      28:copyblock(320-x,ha,ship_pg,172,193,make_pg,x,y,cache);
    end
    else case typ of
      1:if mx>0 then copyblock(la,ha,ship_pg,96,0,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,112,0,make_pg,x,y,cache);
      2:if mx>0 then copyblock(la,ha,ship_pg,128,0,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,144,0,make_pg,x,y,cache);
      3:if mx>0 then copyblock(la,ha,ship_pg,173,0,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,189,0,make_pg,x,y,cache);
      4:if mx>0 then copyblock(la,ha,ship_pg,205,0,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,221,0,make_pg,x,y,cache);
      5:copyblock(la,ha,ship_pg,237,0,make_pg,x,y,cache);
      6:if mx>0 then copyblock(la,ha,ship_pg,0,13,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,47,13,make_pg,x,y,cache);
      7:if mx>0 then copyblock(la,ha,ship_pg,0,73,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,104,73,make_pg,x,y,cache);
      8:if mx>0 then copyblock(la,ha,ship_pg,0,38,make_pg,x,y,cache) else copyblock(la,ha,ship_pg,160,38,make_pg,x,y,cache);
      10..27:copyblock(la,ha,ship_pg,186+(typ-10)*la,191,make_pg,x,y,cache);
      28:copyblock(la,ha,ship_pg,172,193,make_pg,x,y,cache);
    end;
    for j:=1 to 4 do
      if good[j].inplay and (good[j].x+good[j].la>x) and (good[j].x<x+la)
      and (good[j].y+good[j].ha>y) and (good[j].y<y+ha) then
      if typ<10 then begin
	dec(life);
	if life<=0 then begin
	  inc(good[j].score,point(typ));
	  if typ<6 then boum(x+la div 2-7,y+ha div 2-7) else for cmpt:=1 to typ do boum(x+random(la)-7,y+random(ha)-7) ;
	  option(bad[i]);
	end;
	if not lifecod then dec(good[j].life);
	if good[j].life<=0 then begin
	  good[j].inplay:=false;
	  boum(good[j].x+good[j].la div 2-7,good[j].y+good[j].ha div 2-7);
	end;
      end else begin
	inplay:=false;
	with good[j] do case bad[i].typ of
	  10:if life<max_life-max_life div 16 then inc(life,max_life div 16) else life:=max_life;
	  11:if life<max_life-max_life div 8 then inc(life,max_life div 8) else life:=max_life;
	  12:if life<max_life-max_life div 4 then inc(life,max_life div 4) else life:=max_life;
	  13:if life<max_life div 2 then inc(life,max_life div 2) else life:=max_life;
	  14:life:=max_life;

	  15:if fuel<max_fuel-max_fuel div 16 then inc(fuel,max_fuel div 16) else fuel:=max_fuel;
	  16:if fuel<max_fuel-max_fuel div 8 then inc(fuel,max_fuel div 8) else fuel:=max_fuel;
	  17:if fuel<max_fuel-max_fuel div 4 then inc(fuel,max_fuel div 4) else fuel:=max_fuel;
	  18:if fuel<max_fuel div 2 then inc(fuel,max_fuel div 2) else fuel:=max_fuel;
	  19:fuel:=max_fuel;

	  20:inc(score,25);
	  21:inc(score,50);
	  22:inc(score,100);
	  23:inc(score,200);
	  24:inc(score,400);

          25:arme:=0;
          26:arme:=1;
          27:arme:=2;

	  28:for k:=1 to max_bad do with bad[k] do if typ<10 then begin
    	       inc(good[j].score,point(k));
               if bad[k].typ<6 then boum(x+la div 2-7,y+ha div 2-7)
               else for cmpt:=1 to bad[k].typ do boum(x+random(la)-7,y+random(ha)-7);
	       option(bad[k]);
    	     end;
	end;
	playson(2000,10);
	delay(10);
	playson(3000,10);
      end;
    if col_bad then for j:=1 to max_bad do
      if (i<>j) and (typ<10) and (bad[j].typ<10) and bad[j].inplay and (bad[j].x+bad[j].la>x) and (bad[j].x<x+la)
      and (bad[j].y+bad[j].ha>y) and (bad[j].y<y+ha) then begin
      dec(life);
      if life<=0 then begin
        if typ<6 then boum(x+la div 2-7,y+ha div 2-7) else for cmpt:=1 to typ do boum(x+random(la)-7,y+random(ha)-7);
	option(bad[i]);
      end;
      dec(bad[j].life);
      if bad[j].life<=0 then begin
	if bad[j].typ<6 then boum(bad[j].x+bad[j].la div 2-7,bad[j].y+bad[j].ha div 2-7)
        else for cmpt:=1 to bad[j].typ do boum(bad[j].x+random(bad[j].la)-7,bad[j].y+random(bad[j].ha)-7);
	option(bad[j]);
      end;
    end;
    if (typ<>5) and (typ<10) and (random(tir_freq)=0) then
    for j:=1 to max_bad_tirs do if not tir[j].inplay then begin
      tir[j].inplay:=true;
      if mx>0 then tir[j].x:=x+la else tir[j].x:=x;
      tir[j].y:=y+ha div 2;
      tir[j].spe:=mx;
      j:=max_bad_tirs;
    end;
  end;
  for k:=1 to max_bad_tirs do with bad[i].tir[k] do if inplay then begin
    if spe>0 then spe:=spe+miss_acc else spe:=spe-miss_acc;
    inc(x,round(spe));
    if (x<0) or (x>319) then inplay:=false else putpixel(x,y,44);
    for j:=1 to 4 do if good[j].inplay and (x>=good[j].x) and (x<=good[j].x+good[j].la)
    and (y>=good[j].y) and (y<=good[j].y+good[j].ha) then begin
      inplay:=false;
      if not lifecod then dec(good[j].life);
      if good[j].life<=0 then begin
	good[j].inplay:=false;
	boum(good[j].x+good[j].la div 2-7,good[j].y+good[j].ha div 2-7);
      end;
    end;
    if tir_bad then for j:=1 to max_bad do
    if bad[j].inplay and (bad[j].typ<10) and (x>=bad[j].x)
    and (x<=bad[j].x+bad[j].la) and (y>=bad[j].y) and (y<=bad[j].y+bad[j].ha)
    then begin
      inplay:=false;
      dec(bad[j].life);
      if bad[j].life<=0 then begin
	if bad[j].typ<6 then boum(bad[j].x+bad[j].la div 2-7,bad[j].y+bad[j].ha div 2-7)
        else for cmpt:=1 to bad[j].typ do boum(bad[j].x+random(bad[j].la)-7,bad[j].y+random(bad[j].ha)-7);
	option(bad[j]);
      end;
    end;
  end;
end;

begin
  init;
  mise_a_zero;
  repeat
    if scroll then begin
      inc(dif);
      if dif>319 then dif:=0;
      copypage(star_pg,make_pg,dif);
    end else clearpage(make_pg);
    for i:=1 to 4 do move_good;
    for i:=1 to max_bad do begin
      new_bad;
      move_bad;
    end;
    if affich then begin
      with good[1] do begin
        str(score,temp);
        if nom<>'' then outtextxy(0,0,nom+' : '+temp,col);
        if inplay then begin
          for i:=0 to (life*48) div max_life do putpixel(i+7,8,col);
          if fuel<>0 then for i:=0 to (fuel*48) div max_fuel do putpixel(i+7,10,col);
        end;
      end;
      with good[2] do begin
        str(score,temp);
        if nom<>'' then outtextxy(310-length(nom+' : '+temp)*6,0,nom+' : '+temp,col);
        if inplay then begin
          for i:=319 downto 319-(life*48) div max_life do putpixel(i,8,col);
          if fuel<>0 then for i:=319 downto 319-(fuel*48) div max_fuel do putpixel(i,10,col);
        end;
      end;
      with good[3] do begin
        str(score,temp);
        if nom<>'' then outtextxy(0,189,nom+' : '+temp,col);
        if inplay then begin
          for i:=0 to (life*48) div max_life do putpixel(i+7,197,col);
          if fuel<>0 then for i:=0 to (fuel*48) div max_fuel do putpixel(i+7,199,col);
        end;
      end;
      with good[4] do begin
        str(score,temp);
        if nom<>'' then outtextxy(310-length(nom+' : '+temp)*6,189,nom+' : '+temp,col);
        if inplay then begin
          for i:=319 downto 319-(life*48) div max_life do putpixel(i,197,col);
          if fuel<>0 then for i:=319 downto 319-(fuel*48) div max_fuel do putpixel(i,199,col);
        end;
      end;
      if not (good[1].inplay or good[2].inplay or good[3].inplay or good[4].inplay) then show_score;
    end;
    copypage(make_pg,scrn_pg,0);
    delay(pentium);
    if F1 then begin
      mise_a_zero;
      repeat until not F1;
    end;
    if F2 then pause;
  until outgame;
  clearpage(scrn_pg);
  loadpcx('thanks.pcx',scrn_pg);
  repeat until not outgame;
  repeat until outgame;
  uninstallkey;
  close_mode13;
end.
